## docker.io 19.03.4+dfsg2

=== debian/changelog ===
docker.io (19.03.4+dfsg2-2+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 18.06.1+dfsg1-2+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sat, 26 Jan 2019 01:54:38 +0000]
  * Disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Sun, 24 Nov 2019 21:33:26 +0000

docker.io (19.03.4+dfsg2-2) unstable; urgency=medium

  * Removed unused package from Build-Depends.
  * Standards-Version: 4.4.1.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 12 Nov 2019 12:18:22 +1100

docker.io (19.03.4+dfsg2-1) unstable; urgency=medium

  * Bump dfsg version to update orig tarball in the pool.

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Mon, 04 Nov 2019 16:06:27 +0700

docker.io (19.03.4+dfsg1-3) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * get-orig-source.sh: minor shellcheck correction.
  * get-orig-source.sh: consistent/reproducible tarball generation.
  * dev: install "libnetwork/ipvs", as required by Kubernetes.
  * drop "github.com/marstr/guid" (indirect dependency).
  * Un-vendor "golang-github-graylog2-go-gelf-dev".

  [ Arnaud Rebillout ]
  * Stop vendoring docker-go-metrics.
  * Add a patch to fix reverse build-deps against docker/cli.

  [ Dmitry Smirnov ]
  * tighten build-dep
  * disabled unreliable test "TestClientWithRequestTimeout".

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Mon, 04 Nov 2019 14:26:10 +0700

docker.io (19.03.4+dfsg1-2) experimental; urgency=medium

  [ Arnaud Rebillout ]
  * Add patch to fix build against prometheus-client-golang 1.2.1-1

  [ Dmitry Smirnov ]
  * dev to depend on "golang-github-morikuni-aec-dev" (used in
    "pkg/jsonmessage").
  * dev: provide "containerd/labels".

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Wed, 30 Oct 2019 12:19:58 +0700

docker.io (19.03.4+dfsg1-1) experimental; urgency=medium

  * New upstream release [19.03.4].
  * Unvendor a few build dependencies.
  * Drop golang-docker-dev transitional package.

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Sat, 26 Oct 2019 10:39:45 +0700

docker.io (19.03.3+dfsg1-1) experimental; urgency=medium

  * New upstream release [19.03.3].
  * Drop & refresh patches.
  * Update build dependencies.
  * Vendor every dependencies that are missing/outdated in debian.
  * Cherry-pick changes from master (18.09.9+dfsg1-4 to 18.09.9+dfsg2-6).

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Mon, 21 Oct 2019 11:06:43 +0700

docker.io (18.09.9+dfsg2-7) unstable; urgency=medium

  [ Arnaud Rebillout ]
  * Add patch to fix build against prometheus-client-golang 1.2.1-1

  [ Dmitry Smirnov ]
  * get-orig-source.sh: consistent/reproducible tarball generation.
  * dev/install:
    + containerd/labels
    + libnetwork/ipvs

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 31 Oct 2019 19:22:25 +1100

docker.io (18.09.9+dfsg2-6) unstable; urgency=medium

  * (Build-)Depends:
    + golang-github-appc-cni-dev (>= 0.7.1~)
    + golang-github-containerd-go-cni-dev (>= 0.0~git20190904~)
    + golang-github-containernetworking-plugins-dev
    + golang-github-morikuni-aec-dev
  * dev: provide few more containerd components.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 18 Oct 2019 00:05:06 +1100

docker.io (18.09.9+dfsg1-5) unstable; urgency=medium

  [ Arnaud Rebillout ]
  * Drop unused build depends

  [ Dmitry Smirnov ]
  * Patch Docker to use jwt-go v3.
  * Use golang-github-dgrijalva-jwt-go-dev (not -v3).
  * dev: install new "containerd/*" files
         (as required by "singularity-container").

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 08 Oct 2019 14:37:25 +1100

docker.io (18.09.9+dfsg1-4) unstable; urgency=medium

  * d/control: Break/replace/provide containerd-dev (Closes: #941091)
  * d/control: Order and indent a few things

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Wed, 25 Sep 2019 08:07:12 +0700

docker.io (18.09.9+dfsg1-3) unstable; urgency=medium

  [ Arnaud Rebillout ]
  * d/control: Remove duplicate comma in build depends (Closes: #935488)
  * d/control: Standards Version 4.4.0

  [ Dmitry Smirnov ]
  * Provides += golang-github-docker-go-metrics-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 24 Sep 2019 12:45:51 +1000

docker.io (18.09.9+dfsg1-2) unstable; urgency=medium

  * Re-enable engine unit tests again.

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Mon, 16 Sep 2019 13:35:15 +0700

docker.io (18.09.9+dfsg1-1) unstable; urgency=medium

  [ Arnaud Rebillout ]
  * New upstream release [18.09.9].
  * Disable engine unit tests (tmp, until gotestsum makes it to Debian).

  [ Dawid Dziurla ]
  * Install fish completions

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Mon, 16 Sep 2019 11:18:11 +0700

docker.io (18.09.8+dfsg1-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New upstream release [18.09.8].
  * Tighten various dependencies.
  * Update -dev dependencies (for libpod).
  * Backport oci/caps from 19.03.2 (for libpod).
  * Un-vendor golang-github-ishidawataru-sctp-dev.
  * Add upstream patch for libnetwork to build against newer sctp.
  * Add upstream patch to build against
    golang-github-opencontainers-selinux-dev (>= 1.3.0~).
  * No longer disable Go cache to prevent FTBFS with Go 1.12.

  [ Arnaud Rebillout ]
  * github-golang-docker-docker-dev: fix go-metrics install path.
  * github-golang-docker-docker-dev: add replaces/breaks on docker-go-metrics-dev.
  * Add patch to fix Debian security presence check (Closes: #925224).

  [ Reinhard Tartler ]
  * github-golang-docker-docker-dev: add missing sources (Closes: #924257)
  * Additional missing sources for openshift/imagebuilder

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Sat, 14 Sep 2019 10:10:55 +0700

docker.io (18.09.1+dfsg1-9) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * rules: no longer disable Go cache to prevent FTBFS with Go 1.12.

  [ Felix Geyer ]
  * Cherry-pick upstream commits to fix test failures with golang >= 1.11.6-1+deb10u1
  * Add upstream patch for CVE-2019-14271


=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Standards-Version: 4.4.1
Maintainer: Arnaud Rebillout <arnaud.rebillout@collabora.com>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
          ,Tim Potter <tpot@hpe.com>
          ,Tianon Gravi <tianon@debian.org>
          ,Paul Tagliamonte <paultag@debian.org>
#Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: debhelper (>= 11~) ,dh-exec ,dh-golang (>= 1.14~)
    ,bash-completion
    ,ca-certificates
    ,git
    ,golang-any (>= 2:1.10~)
    ,go-md2man (>= 1.0.3~)
    ,gogoprotobuf, libprotobuf-dev
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-etcd-server-dev
    ,golang-github-appc-cni-dev (>= 0.7.1~)
      ,golang-github-containernetworking-plugins-dev
    ,golang-github-armon-go-metrics-dev
    ,golang-github-asaskevich-govalidator-dev
    ,golang-github-aws-aws-sdk-go-dev
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-bshuster-repo-logrus-logstash-hook-dev
    ,golang-github-bsphere-le-go-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-cloudflare-cfssl-dev
    ,golang-github-containerd-btrfs-dev (>= 0.0~git20180306~)
    ,golang-github-containerd-cgroups-dev
    ,golang-github-containerd-console-dev
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-containerd-fifo-dev
    ,golang-github-containerd-go-cni-dev (>= 0.0~git20190904~)
    ,golang-github-containerd-go-runc-dev
    ,golang-github-containerd-typeurl-dev
    ,golang-github-coreos-bbolt-dev (>= 1.3.1-coreos.5-3~)
    ,golang-github-coreos-go-systemd-dev (>= 20~)
    ,golang-github-creack-pty-dev
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-denverdino-aliyungo-dev
    ,golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-dev
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-libtrust-dev
    ,golang-github-docker-notary-dev (>= 0.6.1~) | golang-github-theupdateframework-notary-dev
    ,golang-github-docker-spdystream-dev
    ,golang-github-emicklei-go-restful-dev
    ,golang-github-evanphx-json-patch-dev (>= 4.1.0~)
    ,golang-github-fernet-fernet-go-dev
    ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-garyburd-redigo-dev
    ,golang-github-gofrs-flock-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-googleapis-gnostic-dev
    ,golang-github-google-go-cmp-dev (>= 0.2.0~)
    ,golang-github-google-gofuzz-dev
    ,golang-github-google-shlex-dev
    ,golang-github-google-uuid-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-gotestyourself-gotest.tools-dev
    ,golang-github-graylog2-go-gelf-dev (>= 0.0+git20191017~)
    ,golang-github-grpc-ecosystem-go-grpc-prometheus-dev
#   ,golang-github-grpc-ecosystem-grpc-gateway-dev
    ,golang-github-hashicorp-go-version-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-imdario-mergo-dev (>= 0.3.3~)
    ,golang-github-json-iterator-go-dev (>= 1.1.4~)
    ,golang-github-mattn-go-shellwords-dev
    ,golang-github-mattn-go-sqlite3-dev
    ,golang-github-miekg-dns-dev
    ,golang-github-miekg-pkcs11-dev
    ,golang-github-mitchellh-hashstructure-dev
#   ,golang-github-modern-go-concurrent-dev
    ,golang-github-modern-go-reflect2-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-mrunalp-fileutils-dev
    ,golang-github-ncw-swift-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.3.0~)
    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
    ,golang-github-opentracing-contrib-go-stdlib-dev
    ,golang-github-opentracing-opentracing-go-dev
    ,golang-github-philhofer-fwd-dev
    ,golang-github-pmezard-go-difflib-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-racksec-srslog-dev
    ,golang-github-rcrowley-go-metrics-dev
    ,golang-github-rsc-letsencrypt-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-satori-go.uuid-dev
    ,golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~)
    ,golang-github-shopify-logrus-bugsnag-dev
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
#    ,golang-github-spf13-cobra-dev (>= 0.0.2~)
#    ,golang-github-spf13-pflag-dev
    ,golang-github-stevvooe-ttrpc-dev
    ,golang-github-tchap-go-patricia-dev
    ,golang-github-tinylib-msgp-dev
    ,golang-github-tonistiigi-fifo-dev
    ,golang-github-ugorji-go-codec-dev
    ,golang-github-urfave-cli-dev (>= 1.20.0~)
    ,golang-github-vaughan0-go-ini-dev
    ,golang-github-vbatts-tar-split-dev (>= 0.11.1~)
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev (>= 0.0~git20170707~)
    ,golang-github-xenolf-lego-dev
#   ,golang-glog-dev
    ,golang-gocapability-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-google-dev | golang-golang-x-oauth2-dev
    ,golang-golang-x-time-dev
    ,golang-google-api-dev
    ,golang-google-cloud-dev
    ,golang-google-grpc-dev
    ,golang-gopkg-check.v1-dev
    ,golang-gopkg-inf.v0-dev
    ,golang-goprotobuf-dev (>= 0.0~git20151207~)
    ,golang-go-zfs-dev
    ,golang-protobuf-extensions-dev
    ,libapparmor-dev
    ,libbtrfs-dev | btrfs-progs (<< 4.16.1~)
    ,libdevmapper-dev
    ,pkg-config
    ,procps
    ,tzdata
Homepage: https://mobyproject.org
Vcs-Browser: https://salsa.debian.org/docker-team/docker
Vcs-Git: https://salsa.debian.org/docker-team/docker.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: linux-any
Depends: ${misc:Depends} ,${perl:Depends} ,${shlibs:Depends}
    ,adduser
    ,iptables
    ,lsb-base
    ,runc (>= 1.0.0~rc8~)
    ,tini
Recommends: ${apparmor:Recommends}
    ,ca-certificates
    ,cgroupfs-mount
    ,git
    ,needrestart (>= 3.1~)
    ,xz-utils
Replaces: docker (<< 1.5~)
    ,docker-containerd
    ,docker-runc
    ,golang-libnetwork
Breaks: docker (<< 1.5~)
    ,docker-containerd
    ,docker-runc
    ,golang-libnetwork
Conflicts: docker-containerd
    ,docker-runc
    ,golang-libnetwork
Suggests: docker-doc
    ,aufs-tools
    ,btrfs-progs
    ,debootstrap
    ,e2fsprogs
    ,rinse
    ,xfsprogs
    ,zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-mattn-go-shellwords-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.3.0~)
    ,golang-github-pkg-errors-dev
    ,golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-stretchr-testify-dev
    ,golang-github-tchap-go-patricia-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev (>= 0.0~git20190726~)
    ,golang-google-grpc-dev
    ,golang-gopkg-check.v1-dev
# libnetwork:
    ,golang-dbus-dev (>= 3~)
    ,golang-github-burntsushi-toml-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-go-events-dev
    ,golang-github-gogo-protobuf-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev
# containerd
    ,golang-github-appc-cni-dev (>= 0.7.1~)
      ,golang-github-containernetworking-plugins-dev
    ,golang-github-containerd-fifo-dev
    ,golang-github-tonistiigi-fifo-dev
# moby/buildkit/session
    ,golang-github-opentracing-opentracing-go-dev
Replaces: golang-github-containerd-containerd-dev
    ,golang-github-docker-libnetwork-dev
Breaks: golang-github-containerd-containerd-dev
    ,golang-github-docker-libnetwork-dev
Provides: golang-github-containerd-containerd-dev
    ,golang-github-docker-libnetwork-dev
Description: reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

#Package: golang-github-opencontainers-docker-runc-dev
#Section: oldlibs
#Architecture: all
#Depends: ${misc:Depends}
#    ,golang-github-opencontainers-runc-dev (>= 1.0.0~)
#Description: Open Container Project - development files (Docker's version)
# This is a transitional package to ease upgrades to the
# "golang-github-opencontainers-runc-dev" package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export HOME=$(CURDIR)/debian/tmp

#export DH_GOLANG_BUILDPKG := github.com/docker/docker github.com/docker/cli
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA := testdata/
export DH_GOLANG_EXCLUDES := \
    integration-cli \
    vendor

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)

export DOCKER_VERSION := $(shell cat VERSION)
export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(DOCKER_VERSION))
ifndef DOCKER_GITCOMMIT
  $(error Missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits)
endif

export BUILDTIME := $(shell dpkg-parsechangelog -SDate)

# have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs (we clean it up appropriately ourselves)
export KEEPBUNDLE := 1

## AppArmor can be optionally used in Debian and is there by default in Ubuntu,
## so we need support for it compiled into our binary same story with SELinux.
export DOCKER_BUILDTAGS := apparmor seccomp selinux ambient

## prefer Go 1.7 explicitly if it's available (golang-1.7-go)
#export PATH := /usr/lib/go-1.7/bin:$(PATH)

APPARMOR_RECOMMENDS := $(shell dpkg-vendor --is Ubuntu && echo apparmor)
BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

%:
	dh $@ --buildsystem=golang --with=bash-completion,golang --builddirectory=.gopath

override_dh_clean:
	dh_clean
	$(RM) -v -r autogen bundles man/man*/
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say grep { $$_=q{ */}.$$_ } split(/\s+/,$$1) if m{^Files\-Excluded:\s*(.*?)(?:\n\n|^Files|^Comment:)}sm;' debian/copyright`
	-find */vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
## dh_auto_configure symlinks dirs from "/usr/share/gocode/src" into
## $(OUR_GOPATH) unless folders already exist there in which case files
## are copied. Pre-making directories allows us to use debhelper to
## create proper GOPATH source tree yet have certain directories writable
## even if they are provided by already installed package.
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/cli
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/docker
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/libnetwork
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/swarmkit
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/distribution
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/go-events
	mkdir -pv $(OUR_GOPATH)/src/github.com/containerd/containerd

#	## Prepare builddirectory but throw away sourcedirectory.
	DH_GOPKG="__IGNORE__" dh_auto_configure

## Each package must be removed from working tree first, in case some
## of the packages that we are going to build are already installed.
## This is also useful for building in unclean environment.
##
## This is _necessary_ to avoid merging packages that we build with
## pre-installed packages. See #827226 for details.
## Debhelper knows only about "main" DH_GOPKG package but we build several
## and we have to ensure that build tree is properly prepared.
	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/cli
	cp -ra  cli           $(OUR_GOPATH)/src/github.com/docker/cli

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/docker
	cp -ra  engine        $(OUR_GOPATH)/src/github.com/docker/docker

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/libnetwork
	cp -ra  libnetwork    $(OUR_GOPATH)/src/github.com/docker/libnetwork

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/swarmkit
	cp -ra  swarmkit      $(OUR_GOPATH)/src/github.com/docker/swarmkit

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/distribution
	cp -ra  distribution  $(OUR_GOPATH)/src/github.com/docker/distribution

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/go-events
	cp -ra  go-events     $(OUR_GOPATH)/src/github.com/docker/go-events

	$(RM) -r              $(OUR_GOPATH)/src/github.com/containerd/containerd
	cp -ra  containerd    $(OUR_GOPATH)/src/github.com/containerd/containerd

#	cp -ra  engine/vendor/github.com/docker/distribution          $(OUR_GOPATH)/src/github.com/docker/

override_dh_auto_build-indep:
	# noop

override_dh_auto_build-arch:
## order is important:

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/distribution"    dh_auto_build -v

	DH_GOPKG="github.com/docker/libnetwork"                dh_auto_build -v

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/swarmkit"        dh_auto_build -v

	export DH_GOPKG="github.com/containerd/containerd" ;\
        export REV="`grep $${DH_GOPKG} engine/vendor.conf | head -1 | awk '{print $$2}'`" ;\
        dh_auto_build -v -- -tags "$(DOCKER_BUILDTAGS)" \
          -ldflags "-X $${DH_GOPKG}/version.Version=$(DOCKER_VERSION) -X $${DH_GOPKG}/version.Revision=$${REV}"

	DH_GOPKG="github.com/docker/go-events"                 dh_auto_build -v
	
##	build ("cd" first to ensure we build from within GOPATH)
	cd '$(OUR_GOPATH)/src/github.com/docker/docker' \
        && VERSION=$(DOCKER_VERSION) ./hack/make.sh dynbinary
	
	cd '$(OUR_GOPATH)/src/github.com/docker/cli' \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 LDFLAGS='' \
           $(MAKE) VERSION=$(DOCKER_VERSION) GITCOMMIT=$(DOCKER_GITCOMMIT) dynbinary manpages
	
#	# compile man pages
#	./man/md2man-all.sh -q

override_dh_auto_test-indep:
	#DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
        #dh_auto_test -v --max-parallel=4 -- -short

override_dh_auto_test-arch:
###     [[[ DO NOT DISABLE TESTS ]]]  [[[ DO *NOT* DISABLE TESTS ]]]
	#DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
        #dh_auto_test -v --max-parallel=4 -- -short
ifeq (testsuitedisabled,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

	## Test engine:
#	cd '$(OUR_GOPATH)/src/$(DH_GOPKG)' \
#        && TESTFLAGS='-test.short' ./hack/make.sh test-unit
	cd $(OUR_GOPATH)/src/github.com/docker/docker \
        && TESTFLAGS='-test.short' ./hack/test/unit

	## Test CLI:
	# The following scripts were created with a patch,
	# hence we must set the executable bit by hand.
	chmod +x $(OUR_GOPATH)/src/github.com/docker/cli/scripts/test/unit
	chmod +x $(OUR_GOPATH)/src/github.com/docker/cli/scripts/test/unit-with-coverage
	cd $(OUR_GOPATH)/src/github.com/docker/cli \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit

	.gopath/bin/containerd -version
endif

override_dh_install:
	## Do not install extra license files:
	dh_install -XLICENSE

override_dh_auto_install:
	## skip dh_auto_install to stop dh_golang trying to copy bits
	## for /usr/share/gocode (we use dh_install/dh-exec for that)

override_dh_installinit:
	dh_installinit -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev -v --name=docker --priority=z80

override_dh_gencontrol:
	echo 'apparmor:Recommends=$(APPARMOR_RECOMMENDS)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg2,\
repack,compression=xz,\
uversionmangle=s{\-ce}{};s{(\d)[\-]?((rc|beta)\d*)$}{$1~$2},\
dversionmangle=s{[+~](dfsg|ds)\d*}{},\
" https://uscan.tianon.xyz/github.com/docker/docker-ce \
  .*/archive/v(\d\S*)\.tar\.gz debian ./debian/get-orig-source.sh

# /(releases|tags) paginates too soon on github.com
# so we lose historical versions too early for tianon's taste.
# https://github.com/docker/docker/releases

## docker.io 19.03.5+dfsg1

=== debian/changelog ===
docker.io (19.03.5+dfsg1-2) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * Removed unused "golang-github-rsc-letsencrypt-dev" from Build-Depends.
  * Removed unused "golang-github-xenolf-lego-dev" from Build-Depends.
  * Build-Depends += "golang-github-codegangsta-cli-dev"
  * Don't run Btrfs tests ('chown' is not permitted).
  * Removed unused "golang-github-vaughan0-go-ini-dev" fron Build-Depends.

  [ Arnaud Rebillout ]
  * Build-Depends += "gotestsum", drop related patches
  * Drop buildkit patch
  * Update patch that disables hcsshim
  * Add patch to build against vishvananda/libnetwork 1.1.x
  * Add upstream patch to fix test against imdario/mergo 0.3.8

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Thu, 06 Feb 2020 16:00:33 +0700

docker.io (19.03.5+dfsg1-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * Added Conflicts with Docker's vendor packages (docker-ce, containerd.io)

  [ Arnaud Rebillout ]
  * New upstream release [19.03.5].

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Wed, 18 Dec 2019 17:51:41 +0700

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
     ,golang-github-bsphere-le-go-dev
     ,golang-github-burntsushi-toml-dev
     ,golang-github-cloudflare-cfssl-dev
+    ,golang-github-codegangsta-cli-dev
     ,golang-github-containerd-btrfs-dev (>= 0.0~git20180306~)
     ,golang-github-containerd-cgroups-dev
     ,golang-github-containerd-console-dev
@@ -98,7 +99,6 @@
     ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
     ,golang-github-racksec-srslog-dev
     ,golang-github-rcrowley-go-metrics-dev
-    ,golang-github-rsc-letsencrypt-dev
     ,golang-github-samuel-go-zookeeper-dev
     ,golang-github-satori-go.uuid-dev
     ,golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~)
@@ -112,11 +112,9 @@
     ,golang-github-tonistiigi-fifo-dev
     ,golang-github-ugorji-go-codec-dev
     ,golang-github-urfave-cli-dev (>= 1.20.0~)
-    ,golang-github-vaughan0-go-ini-dev
     ,golang-github-vbatts-tar-split-dev (>= 0.11.1~)
     ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
     ,golang-github-vishvananda-netns-dev (>= 0.0~git20170707~)
-    ,golang-github-xenolf-lego-dev
 #   ,golang-glog-dev
     ,golang-gocapability-dev
     ,golang-golang-x-net-dev
@@ -130,6 +128,7 @@
     ,golang-goprotobuf-dev (>= 0.0~git20151207~)
     ,golang-go-zfs-dev
     ,golang-protobuf-extensions-dev
+    ,gotestsum
     ,libapparmor-dev
     ,libbtrfs-dev | btrfs-progs (<< 4.16.1~)
     ,libdevmapper-dev
@@ -166,6 +165,10 @@
 Conflicts: docker-containerd
     ,docker-runc
     ,golang-libnetwork
+## Docker's vendor packages:
+    ,docker-ce
+    ,docker-ce-cli
+    ,containerd.io
 Suggests: docker-doc
     ,aufs-tools
     ,btrfs-progs

=== debian/rules ===
--- 
+++ 
@@ -131,14 +131,14 @@
 #	./man/md2man-all.sh -q
 
 override_dh_auto_test-indep:
-	#DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
-        #dh_auto_test -v --max-parallel=4 -- -short
+	DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
+        dh_auto_test -v --max-parallel=4 -- -short
 
 override_dh_auto_test-arch:
 ###     [[[ DO NOT DISABLE TESTS ]]]  [[[ DO *NOT* DISABLE TESTS ]]]
-	#DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
-        #dh_auto_test -v --max-parallel=4 -- -short
-ifeq (testsuitedisabled,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
+        dh_auto_test -v --max-parallel=4 -- -short
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 
 	## Test engine:
 #	cd '$(OUR_GOPATH)/src/$(DH_GOPKG)' \
@@ -147,10 +147,6 @@
         && TESTFLAGS='-test.short' ./hack/test/unit
 
 	## Test CLI:
-	# The following scripts were created with a patch,
-	# hence we must set the executable bit by hand.
-	chmod +x $(OUR_GOPATH)/src/github.com/docker/cli/scripts/test/unit
-	chmod +x $(OUR_GOPATH)/src/github.com/docker/cli/scripts/test/unit-with-coverage
 	cd $(OUR_GOPATH)/src/github.com/docker/cli \
         && DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit

## docker.io 19.03.6

=== components/packaging/Makefile ===
include common.mk

CLI_DIR:=$(realpath $(CURDIR)/../cli)
ENGINE_DIR:=$(realpath $(CURDIR)/../engine)
STATIC_VERSION:=$(shell static/gen-static-ver $(ENGINE_DIR) $(VERSION))

# Taken from: https://www.cmcrossroads.com/article/printing-value-makefile-variable
print-%  : ; @echo $($*)

.PHONY: help
help: ## show make targets
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {sub("\\\\n",sprintf("\n%22c"," "), $$2);printf " \033[36m%-20s\033[0m  %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: clean-engine
clean-engine:
	rm -rf $(ENGINE_DIR)

.PHONY: clean-image
clean-image:
	$(MAKE) ENGINE_DIR=$(ENGINE_DIR) -C image clean


.PHONY: clean
clean: clean-image ## remove build artifacts
	$(MAKE) -C rpm clean
	$(MAKE) -C deb clean
	$(MAKE) -C static clean

.PHONY: rpm
rpm: DOCKER_BUILD_PKGS:=$(shell find rpm -type d | grep ".*-.*" | sed 's/^rpm\///')
rpm: ## build rpm packages
	for p in $(DOCKER_BUILD_PKGS); do \
		$(MAKE) -C $@ VERSION=$(VERSION) ENGINE_DIR=$(ENGINE_DIR) CLI_DIR=$(CLI_DIR) GO_VERSION=$(GO_VERSION) $${p}; \
	done

.PHONY: deb
deb: DOCKER_BUILD_PKGS:=$(shell find deb -type d | grep ".*-.*" | sed 's/^deb\///')
deb: ## build deb packages
	for p in $(DOCKER_BUILD_PKGS); do \
		$(MAKE) -C $@ VERSION=$(VERSION) ENGINE_DIR=$(ENGINE_DIR) CLI_DIR=$(CLI_DIR) GO_VERSION=$(GO_VERSION) $${p}; \
	done

.PHONY: static
static: DOCKER_BUILD_PKGS:=static-linux cross-mac cross-win cross-arm
static: ## build static-compiled packages
	for p in $(DOCKER_BUILD_PKGS); do \
		$(MAKE) -C $@ VERSION=$(VERSION) ENGINE_DIR=$(ENGINE_DIR) CLI_DIR=$(CLI_DIR) GO_VERSION=$(GO_VERSION) $${p}; \
	done

# TODO - figure out multi-arch
.PHONY: image
image: DOCKER_BUILD_PKGS:=image-linux
image: ## build static-compiled packages
	for p in $(DOCKER_BUILD_PKGS); do \
		$(MAKE) -C $@ VERSION=$(VERSION) ENGINE_DIR=$(ENGINE_DIR) CLI_DIR=$(CLI_DIR) GO_VERSION=$(GO_VERSION) $${p}; \
	done

engine-$(ARCH).tar:
	$(MAKE) -C image $@

.PHONY: release
release:
	$(MAKE) -C image $@

=== components/packaging/deb/Makefile ===
include ../common.mk

CLI_DIR:=$(realpath $(CURDIR)/../../cli)
ENGINE_DIR:=$(realpath $(CURDIR)/../../engine)
PLUGINS_DIR:=$(realpath $(CURDIR)/../plugins)
GITCOMMIT?=$(shell cd $(CLI_DIR) && git rev-parse --short HEAD)
STATIC_VERSION:=$(shell ../static/gen-static-ver $(ENGINE_DIR) $(VERSION))
GO_BASE_IMAGE=golang
GO_IMAGE=$(GO_BASE_IMAGE):$(GO_VERSION)-stretch
DEB_VERSION=$(shell ./gen-deb-ver $(CLI_DIR) "$(VERSION)")
CHOWN:=docker run --rm -v $(CURDIR):/v -w /v alpine chown
EPOCH?=5

ifdef BUILD_IMAGE
	BUILD_IMAGE_FLAG=--build-arg $(BUILD_IMAGE)
endif

COMMON_FILES=common
BUILD?=docker build \
	$(BUILD_IMAGE_FLAG) \
	--build-arg GO_IMAGE=$(GO_IMAGE) \
	--build-arg COMMON_FILES=$(COMMON_FILES) \
	-t debbuild-$@/$(ARCH) \
	-f $(CURDIR)/$@/Dockerfile .
# Additional flags may be necessary at some point
RUN_FLAGS=
RUN=docker run --rm -i \
	-e EPOCH='$(EPOCH)' \
	-e DEB_VERSION=$(word 1, $(DEB_VERSION)) \
	-e VERSION=$(word 2, $(DEB_VERSION)) \
	-e DOCKER_GITCOMMIT=$(GITCOMMIT) \
	-e PLATFORM \
	-v $(CURDIR)/debbuild/$@:/build \
	$(RUN_FLAGS) \
	debbuild-$@/$(ARCH)

SOURCE_FILES=engine-image cli.tgz engine.tgz docker.service docker.socket distribution_based_engine.json plugin-installers.tgz
SOURCES=$(addprefix sources/, $(SOURCE_FILES))

.PHONY: help
help: ## show make targets
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {sub("\\\\n",sprintf("\n%22c"," "), $$2);printf " \033[36m%-20s\033[0m  %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: clean
clean: ## remove build artifacts
	[ ! -d debbuild ] || $(CHOWN) -R $(shell id -u):$(shell id -g) debbuild
	$(RM) -r debbuild
	[ ! -d sources ] || $(CHOWN) -R $(shell id -u):$(shell id -g) sources
	$(RM) -r sources
	$(RM) engine-image

engine-$(ARCH).tar:
	$(MAKE) -C ../image image-linux
	docker save -o $@ $$(cat ../image/image-linux)

.PHONY: deb
deb: ubuntu debian raspbian ## build all deb packages

.PHONY: ubuntu
ubuntu: ubuntu-bionic ubuntu-xenial ubuntu-disco ubuntu-eoan  ## build all ubuntu deb packages

.PHONY: debian
debian: debian-stretch debian-buster ## build all debian deb packages

.PHONY: raspbian
raspbian: raspbian-stretch raspbian-buster ## build all raspbian deb packages

.PHONY: ubuntu-%
## build ubuntu deb packages
ubuntu-%: $(SOURCES)
	$(BUILD)
	$(RUN)
	$(CHOWN) -R $(shell id -u):$(shell id -g) debbuild/$@

.PHONY: debian-%
## build debian deb packages
debian-%: $(SOURCES)
	$(BUILD)
	$(RUN)
	$(CHOWN) -R $(shell id -u):$(shell id -g) debbuild/$@

.PHONY: raspbian-%
## build raspbian deb packages
raspbian-%: $(SOURCES)
	$(BUILD)
	$(RUN)
	$(CHOWN) -R $(shell id -u):$(shell id -g) debbuild/$@

sources/engine.tgz:
	mkdir -p $(@D)
	docker run --rm -i -w /v \
		-v $(ENGINE_DIR):/engine \
		-v $(CURDIR)/$(@D):/v \
		alpine \
		tar -C / -c -z -f /v/engine.tgz --exclude .git engine

sources/cli.tgz:
	mkdir -p $(@D)
	docker run --rm -i -w /v \
		-v $(CLI_DIR):/cli \
		-v $(CURDIR)/$(@D):/v \
		alpine \
		tar -C / -c -z -f /v/cli.tgz --exclude .git cli

sources/docker.service: ../systemd/docker.service
	mkdir -p $(@D)
	cp $< $@

sources/docker.socket: ../systemd/docker.socket
	mkdir -p $(@D)
	cp $< $@

# TODO: Figure out how to decouple this
# TODO: These might just end up being static files that are hardcoded
# TODO: FROM HERE <=====================
sources/distribution_based_engine.json: sources/engine-image
	mkdir -p $(@D)
	echo '{"platform":"Docker Engine - Community","engine_image":"engine-community","containerd_min_version":"1.2.0-beta.1","runtime":"host_install"}' > $@

sources/engine-image:
	mkdir -p $(@D)
	echo "docker.io/dockereng/engine-community:$(STATIC_VERSION)" > $@
# TODO: TO HERE <=====================

sources/plugin-installers.tgz: $(wildcard ../plugins/*)
	docker run --rm -i -w /v \
		-v $(PLUGINS_DIR):/plugins \
		-v $(CURDIR)/sources:/v \
		alpine \
		tar -C / -c -z -f /v/plugin-installers.tgz --exclude .git plugins

=== components/packaging/image/Makefile ===
include ../common.mk

CLI_DIR:=$(realpath $(CURDIR)/../../cli)
ENGINE_DIR:=$(realpath $(CURDIR)/../../engine)
GO_BASE_IMAGE=golang
ENGINE_GO_IMAGE=$(GO_BASE_IMAGE):$(GO_VERSION)-stretch
STATIC_VERSION:=$(shell ../static/gen-static-ver $(ENGINE_DIR) $(VERSION))
DOCKER_HUB_ORG?=dockereng
ENGINE_IMAGE?=engine-community
CHOWN:=docker run --rm -v $(CURDIR):/v -w /v alpine chown
IMAGE_WITH_TAG=$(DOCKER_HUB_ORG)/$(ENGINE_IMAGE):$(STATIC_VERSION)
ifdef BASE_IMAGE
	# TODO: Clean this up to only set ENGINE_GO_IMAGE
	BASE_IMAGE_FLAG=--build-arg BASE_IMAGE=$(BASE_IMAGE)
	ENGINE_GO_IMAGE=$(BASE_IMAGE)
endif
IMAGE_BUILD?=docker build -t  $(IMAGE_WITH_TAG) \
	--build-arg GO_IMAGE="$(ENGINE_GO_IMAGE)" \
	--build-arg VERSION="$(STATIC_VERSION)" \
	--build-arg GITCOMMIT="$$(cd $(ENGINE_DIR) && git rev-parse --short=7 HEAD)" \
	--build-arg BUILDTIME="$(BUILDTIME)" \
	--build-arg PLATFORM="$(PLATFORM)" \
	--build-arg PRODUCT="$(PRODUCT)" \
	--build-arg ENGINE_IMAGE="$(ENGINE_IMAGE)" \
	--build-arg DEFAULT_PRODUCT_LICENSE="$(DEFAULT_PRODUCT_LICENSE)" \
	$(BASE_IMAGE_FLAG) \
	--file $< $(ENGINE_DIR)

.PHONY: help
help: ## show make targets
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {sub("\\\\n",sprintf("\n%22c"," "), $$2);printf " \033[36m%-20s\033[0m  %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: clean
clean: ## remove build artifacts
	-$(RM) $(ENGINE_DIR)/Dockerfile.engine
	-$(RM) $(ENGINE_DIR)/Dockerfile.engine-dm
	-docker rmi $(IMAGE_WITH_TAG)
	-docker rmi $(IMAGE_WITH_TAG)-dm
	-rm -f image-linux
	-$(RM) -r artifacts
	-$(RM) *.tar

.PHONY: image
image: image-linux

$(ENGINE_DIR)/Dockerfile.%: Dockerfile.%
	cp $< $@

DOCKER2OCI=artifacts/docker2oci
$(DOCKER2OCI):
	-$(CHOWN) -R $(shell id -u):$(shell id -g) $(@D)
	docker run --name docker2oci $(ENGINE_GO_IMAGE) sh -c 'go get github.com/coolljt0725/docker2oci'
	mkdir -p $(@D)
	docker cp docker2oci:/go/bin/docker2oci "$@"
	docker rm -f docker2oci
	$(CHOWN) -R $(shell id -u):$(shell id -g) $(@D)

# builds across multiple archs because the base images
# utilize manifests
image-linux: $(ENGINE_DIR)/Dockerfile.engine
	$(IMAGE_BUILD)
	echo $(IMAGE_WITH_TAG) > $@

engine-$(ARCH).tar: engine-$(ARCH)-docker-compat.tar $(DOCKER2OCI)
	mkdir -p artifacts
	./$(DOCKER2OCI) -i $< artifacts/engine-image
	mkdir -p $(@D)
	tar c -C artifacts/engine-image . > $@

engine-$(ARCH)-docker-compat.tar: image-linux
	docker save -o $@ $$(cat $<)

image-linux-dm: ENGINE_IMAGE:=$(ENGINE_IMAGE)-dm
image-linux-dm: $(ENGINE_DIR)/Dockerfile.engine-dm
	$(IMAGE_BUILD)
	echo $(IMAGE_WITH_TAG) > $@

engine-$(ARCH)-dm.tar: engine-$(ARCH)-dm-docker-compat.tar $(DOCKER2OCI)
	mkdir -p artifacts
	./$(DOCKER2OCI) -i $< artifacts/engine-image
	mkdir -p $(@D)
	tar c -C artifacts/engine-image . > $@

engine-$(ARCH)-dm-docker-compat.tar: image-linux-dm
	docker save -o $@ $$(cat $<)

=== components/packaging/rpm/Makefile ===
include ../common.mk

CLI_DIR:=$(realpath $(CURDIR)/../../cli)
ENGINE_DIR:=$(realpath $(CURDIR)/../../engine)
PLUGINS_DIR=$(realpath $(CURDIR)/../plugins)
GITCOMMIT=$(shell cd $(ENGINE_DIR) && git rev-parse --short HEAD)
STATIC_VERSION:=$(shell ../static/gen-static-ver $(ENGINE_DIR) $(VERSION))
GO_BASE_IMAGE=golang
GO_IMAGE?=$(GO_BASE_IMAGE):$(GO_VERSION)-stretch
GEN_RPM_VER=$(shell ./gen-rpm-ver $(CLI_DIR) $(VERSION))
CHOWN=docker run --rm -i -v $(CURDIR):/v -w /v alpine chown

DOCKERFILE=Dockerfile
ifdef NEEDS_ARCH_SPECIFIC
	DOCKERFILE=Dockerfile.$(ARCH)
endif
ifdef BUILD_IMAGE
	BUILD_IMAGE_FLAG=--build-arg $(BUILD_IMAGE)
endif
BUILD?=docker build \
	$(BUILD_IMAGE_FLAG) \
	--build-arg GO_IMAGE=$(GO_IMAGE) \
	-t rpmbuild-$@/$(ARCH) \
	-f $@/$(DOCKERFILE) \
	.

SPEC_FILES?=docker-ce.spec docker-ce-cli.spec
SPECS?=$(addprefix SPECS/, $(SPEC_FILES))
RPMBUILD=docker run --privileged --rm -i \
	-e PLATFORM \
	-v $(CURDIR)/rpmbuild/SOURCES:/root/rpmbuild/SOURCES \
	-v $(CURDIR)/rpmbuild/RPMS:/root/rpmbuild/RPMS \
	-v $(CURDIR)/rpmbuild/SRPMS:/root/rpmbuild/SRPMS
RPMBUILD_FLAGS?=-ba\
	--define '_gitcommit $(word 3,$(GEN_RPM_VER))' \
	--define '_release $(word 2,$(GEN_RPM_VER))' \
	--define '_version $(word 1,$(GEN_RPM_VER))' \
	--define '_origversion $(word 4, $(GEN_RPM_VER))' \
	$(SPECS)
RUN?=$(RPMBUILD) rpmbuild-$@/$(ARCH) $(RPMBUILD_FLAGS)

SOURCE_FILES=engine-image engine.tgz cli.tgz docker.service docker.socket distribution_based_engine.json plugin-installers.tgz
SOURCES=$(addprefix rpmbuild/SOURCES/, $(SOURCE_FILES))

.PHONY: help
help: ## show make targets
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {sub("\\\\n",sprintf("\n%22c"," "), $$2);printf " \033[36m%-20s\033[0m  %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: clean
clean: ## remove build artifacts
	[ ! -d rpmbuild ] || $(CHOWN) -R $(shell id -u):$(shell id -g) rpmbuild
	$(RM) -r rpmbuild/
	[ ! -d artifacts ] || $(CHOWN) -R $(shell id -u):$(shell id -g) artifacts
	$(RM) -r artifacts/
	[ ! -d tmp ] || $(CHOWN) -R $(shell id -u):$(shell id -g) tmp
	$(RM) -r tmp/
	-docker rm docker2oci
	$(MAKE) -C ../image clean

.PHONY: rpm
rpm: fedora centos ## build all rpm packages

.PHONY: fedora
fedora: fedora-31 fedora-30 fedora-29 fedora-28 ## build all fedora rpm packages

.PHONY: centos
centos: centos-7 ## build all centos rpm packages

.PHONY: fedora-%
fedora-%: ## build fedora rpm packages
fedora-%: $(SOURCES)
	$(CHOWN) -R root:root rpmbuild
	$(BUILD)
	$(RUN)
	$(CHOWN) -R $(shell id -u):$(shell id -g) rpmbuild

.PHONY: centos-7
centos-7: ## build centos-7 rpm packages
centos-7: $(SOURCES)
	$(CHOWN) -R root:root rpmbuild
	$(BUILD)
	$(RUN)
	$(CHOWN) -R $(shell id -u):$(shell id -g) rpmbuild

rpmbuild/SOURCES/engine.tgz:
	mkdir -p rpmbuild/SOURCES
	docker run --rm -i -w /v \
		-v $(ENGINE_DIR):/engine \
		-v $(CURDIR)/rpmbuild/SOURCES:/v \
		alpine \
		tar -C / -c -z -f /v/engine.tgz --exclude .git engine

rpmbuild/SOURCES/cli.tgz:
	mkdir -p rpmbuild/SOURCES
	docker run --rm -i -w /v \
		-v $(CLI_DIR):/cli \
		-v $(CURDIR)/rpmbuild/SOURCES:/v \
		alpine \
		tar -C / -c -z -f /v/cli.tgz --exclude .git cli

rpmbuild/SOURCES/docker.service: ../systemd/docker.service
	mkdir -p $(@D)
	cp $< $@

rpmbuild/SOURCES/docker.socket: ../systemd/docker.socket
	mkdir -p $(@D)
	cp $< $@

# TODO: Figure out how to decouple this
# TODO: These might just end up being static files that are hardcoded
# TODO: FROM HERE <=====================
rpmbuild/SOURCES/engine-image:
	mkdir -p $(@D)
	echo "docker.io/dockereng/engine-community-dm:$(STATIC_VERSION)" > $@

rpmbuild/SOURCES/distribution_based_engine.json: rpmbuild/SOURCES/engine-image
	mkdir -p $(@D)
	echo '{"platform":"Docker Engine - Community","engine_image":"engine-community-dm","containerd_min_version":"1.2.0-beta.1","runtime":"host_install"}' > $@
# TODO: TO HERE <=====================

rpmbuild/SOURCES/plugin-installers.tgz: $(wildcard ../plugins/*)
	docker run --rm -i -w /v \
		-v $(PLUGINS_DIR):/plugins \
		-v $(CURDIR)/rpmbuild/SOURCES:/v \
		alpine \
		tar -C / -c -z -f /v/plugin-installers.tgz --exclude .git plugins

=== components/packaging/static/Makefile ===
include ../common.mk

CLI_DIR:=$(realpath $(CURDIR)/../../cli)
ENGINE_DIR:=$(realpath $(CURDIR)/../../engine)
STATIC_VERSION:=$(shell ./gen-static-ver $(ENGINE_DIR) $(VERSION))
CHOWN=docker run --rm -v $(CURDIR):/v -w /v alpine chown
HASH_CMD=docker run -v $(CURDIR):/sum -w /sum debian:jessie bash hash_files
DIR_TO_HASH:=build/linux
GO_VERSION=$(shell grep "ARG GO_VERSION" $(CLI_DIR)/dockerfiles/Dockerfile.dev | awk -F'=' '{print $$2}')
DOCKER_CLI_GOLANG_IMG=golang:$(GO_VERSION)

.PHONY: help
help: ## show make targets
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {sub("\\\\n",sprintf("\n%22c"," "), $$2);printf " \033[36m%-20s\033[0m  %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: clean
clean: ## remove build artifacts
	[ ! -d build ] || $(CHOWN) -R $(shell id -u):$(shell id -g) build
	$(RM) -r build

.PHONY: static
static: static-linux cross-mac cross-win cross-arm ## create all static packages

.PHONY: static-linux
static-linux: static-cli static-engine ## create tgz with linux x86_64 client and server
	mkdir -p build/linux/docker
	cp $(CLI_DIR)/build/docker build/linux/docker/
	for f in dockerd containerd ctr containerd-shim docker-init docker-proxy runc; do \
		cp -L $(ENGINE_DIR)/bundles/binary-daemon/$$f build/linux/docker/$$f; \
	done
	tar -C build/linux -c -z -f build/linux/docker-$(STATIC_VERSION).tgz docker

	# extra binaries for running rootless
	mkdir -p build/linux/docker-rootless-extras
	for f in rootlesskit rootlesskit-docker-proxy dockerd-rootless.sh vpnkit; do \
		if [ -f $(ENGINE_DIR)/bundles/binary-daemon/$$f ]; then \
			cp -L $(ENGINE_DIR)/bundles/binary-daemon/$$f build/linux/docker-rootless-extras/$$f; \
		fi \
	done
	tar -C build/linux -c -z -f build/linux/docker-rootless-extras-$(STATIC_VERSION).tgz docker-rootless-extras

.PHONY: hash_files
hash_files:
	@echo "Hashing directory $(DIR_TO_HASH)"
	$(HASH_CMD) "$(DIR_TO_HASH)"

.PHONY: cross-mac
cross-mac: cross-all-cli cross-mac-plugins ## create tgz with darwin x86_64 client only
	mkdir -p build/mac/docker
	cp $(CLI_DIR)/build/docker-darwin-amd64 build/mac/docker/docker
	tar -C build/mac -c -z -f build/mac/docker-$(STATIC_VERSION).tgz docker

.PHONY: cross-win
cross-win: cross-all-cli cross-win-engine cross-win-plugins ## create zip file with windows x86_64 client and server
	mkdir -p build/win/docker
	cp $(CLI_DIR)/build/docker-windows-amd64 build/win/docker/docker.exe
	cp $(ENGINE_DIR)/bundles/cross/windows/amd64/dockerd-$(STATIC_VERSION).exe build/win/docker/dockerd.exe
	docker run --rm -v $(CURDIR)/build/win:/v -w /v alpine sh -c 'apk update&&apk add zip&&zip -r docker-$(STATIC_VERSION).zip docker'
	$(CHOWN) -R $(shell id -u):$(shell id -g) build

.PHONY: cross-arm
cross-arm: cross-all-cli ## create tgz with linux armhf client only
	mkdir -p build/arm/docker
	cp $(CLI_DIR)/build/docker-linux-arm build/arm/docker/docker
	tar -C build/arm -c -z -f build/arm/docker-$(STATIC_VERSION).tgz docker

.PHONY: static-cli
static-cli:
	$(MAKE) -C $(CLI_DIR) -f docker.Makefile VERSION=$(STATIC_VERSION) build

.PHONY: static-engine
static-engine:
	$(MAKE) -C $(ENGINE_DIR) VERSION=$(STATIC_VERSION) binary

.PHONY: cross-all-cli
cross-all-cli:
	$(MAKE) -C $(CLI_DIR) -f docker.Makefile VERSION=$(STATIC_VERSION) cross

.PHONY: cross-win-engine
cross-win-engine:
	$(MAKE) -C $(ENGINE_DIR) VERSION=$(STATIC_VERSION) DOCKER_CROSSPLATFORMS=windows/amd64 cross

BUILD_PLUGIN_RUN_VARS = --rm -i \
	-e GOOS=$(SPOOF_GOOS) \
	-v "$(CURDIR)/build/$(CLI_BUILD_DIR)/docker/cli-plugins":/out \
	-v "$(CURDIR)/../plugins":/plugins:ro \
	-v "$(CURDIR)/scripts/build-cli-plugins":/build:ro

.PHONY: cross-mac-plugins
cross-mac-plugins: SPOOF_GOOS := darwin
cross-mac-plugins: CLI_BUILD_DIR := mac
cross-mac-plugins:
	mkdir -p build/$(CLI_BUILD_DIR)/docker
	docker run $(BUILD_PLUGIN_RUN_VARS) $(DOCKER_CLI_GOLANG_IMG) /build
	$(CHOWN) -R $(shell id -u):$(shell id -g) build

.PHONY: cross-win-plugins
cross-win-plugins: SPOOF_GOOS := windows
cross-win-plugins: CLI_BUILD_DIR := win
cross-win-plugins:
	mkdir -p build/$(CLI_BUILD_DIR)/docker/cli-plugins
	docker run $(BUILD_PLUGIN_RUN_VARS) $(DOCKER_CLI_GOLANG_IMG) /build
	$(CHOWN) -R $(shell id -u):$(shell id -g) build
	find build/$(CLI_BUILD_DIR)/docker -type f -not -name "*.exe" -exec mv {} {}.exe \;

=== debian/changelog ===
docker.io (19.03.6-0ubuntu1~19.10.1) eoan; urgency=medium

  * Backport to eoan. (LP: #1863669)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 19 Feb 2020 14:04:38 +1300

docker.io (19.03.6-0ubuntu1) focal; urgency=medium

  * Update to 19.03.6 upstream release

 -- Tianon Gravi <tianon@debian.org>  Tue, 18 Feb 2020 09:03:26 +1300
